unit CriqArquivo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs,StdCtrls, Mask, DBCtrls, DB, DBTables,
  Buttons, ExtCtrls,TabNotBk,Printers,ComCtrls;
type


  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
var
  Form1: TForm1;
  Function LTrim(Text : String) : String;
  function Rtrim(Text : string) : string;
  function ChecaCampo(sTipoCampo:String):TFieldType;
  function CriaArquivoIndices(sIndices:String):TIndexOptions;
  function AllTrim(InString: string): string;
  function CriaArquivo(sDiretorio,sArquivo:String ;
                          aStruturaDados:Array of string;
                          aIndices:Array of string
                           ):Boolean;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
   If not FileExists('c:\temp\Teste.db') then
       CriaArquivo('c:\temp',
                       'Teste.Db',
                      ['Codigo      ','A','05','f' ,
                       'Nome        ','C','40','f' ,
                       'Endereco    ','C','30','f' ,
                       'DTVencimento','D','00','f' ,
                       'Ativo       ','L','00','f' ,
                       'Vendas      ','#','02','f' ,
                       'Observacoes ','M','00','f'],
                       [' Codigo','Codigo','Pu',
                        ' Nome  ','Nome  ','d',
                        'xxNome ','Nome;Endereco','D'])

end;
/////////////////////////////////////////////////////////////////////
/////////////    Rotina p/ Criao de Arquivos Db
function CriaArquivo(sDiretorio,sArquivo:String ;
                          aStruturaDados:Array of string;
                          aIndices:Array of string):Boolean;

(* Autor.....: Edmar de Oliveira Frazo
   Data......: 01/12/1997
   Modificada: 16/01/1998
   email.....: edmar@netfor.com.br

Exemplo:      CriaArquivo('c:\temp',
                       'Teste.Db',
                      ['Codigo      ','A','05','f' ,
                       'Nome        ','C','40','f' ,
                       'Endereco    ','C','30','f' ,
                       'DTVencimento','D','00','f' ,
                       'Ativo       ','L','00','f' ,
                       'Vendas      ','#','02','f' ,
                       'Observacoes ','M','00','f'],
                       [' Codigo','Codigo','Pu',
                        ' Nome  ','Nome  ','d',
                        'xxNome ','Nome;Endereco','D'])
Ps. Esta rotina podera ser altera ou mudificada , sem qualquer onus p/
     ambas as partes.
   Se alguem a altera-l p/ uso , se possivel enviar-me uma copia.
      Gratos.
      Edmar Frazo.

   Rotina de criacao de Arquivo no estido Dbcreate do Clipper, foi
   criado uma matriz string onde deve-se informa a estrutura dos
   arquivo na ordem:
      Campo,TipoCampo,Tamanho,Logico
      ou seja p/ cada campo do arquivo dever haver uma sequencia de 04
      strings.
      Tipo de Campos aceitos(podendo ser acrecentado outros), sendo
      aceitos em Letras maiusculas ou minusculas.
      {CNAIDT#GML} ou seja
          {ftstring,ftSmallint,ftString,ftDate,ftTime,ftBCD,
          ftGraphic,ftMemo,ftBoolena}
   p/ os indices a ordem
      NomedoIndice,NomedoCampo,TipodaOrdenacao }
      Tipo de ordenacao dos Indices(podendo ser acrecentado outros), sendo
      aceitos em Letras maiusculas ou minusculas.
      {PUDEC} ou seja
         {ixPrimary,ixUnique,ixDescending,ixExpression,ixCaseInsensiteve}
      Podendo combinar mais de um tipo de ordem ex:
         'PU', [ixPrimary,ixUnique]
*)
Var
   iContador,iLimite:Integer ;
   sChaveIndice,sNomeIndice,sIndice,sNomeCampo:String;
   sTipoCampo:String[1];
   fTipoCampo:TFieldType;
   iTamanhoCampo:Integer;
   bRequeridoCampo:Boolean;
   tTabela:TTable;
Begin
 Try
   Try
    tTabela:= TTable.Create(Application);
    iLimite:=(High(aStruturaDados)+1) div 4;
    If ((iLimite*4) <> (High(aStruturaDados)+1)) or
        ((((High(aIndices)+1) div 3)*3)<> (High(aIndices)+1)) then
        Begin
           If ((iLimite*4) <> (High(aStruturaDados)+1)) then
                  ShowMessage('Estrutura dos Dados esta incorreta, '#13
                   +'tem que ser Multiplos de 4')
           else
                  ShowMessage('Estrutura dos Indices esta incorreta, '#13
                   +'tem que ser Multiplos de 3');

        end
    else
    Begin
     With tTabela do
      Begin
        Active       := false;
        TableType    := ttParadox;
        DatabaseName := sDiretorio;
        TableName    := sArquivo;
        FieldDefs.Clear;
      end;
     For iContador:=1 to iLimite do
     Begin
        sNomeCampo                       := aStruturaDados[((iContador*4)-4)];
        sTipoCampo                       := aStruturaDados[((iContador*4)-3)];
        fTipoCampo                       := ChecaCampo(sTipoCampo);
        iTamanhoCampo                    := StrtoInt(aStruturaDados[((iContador*4)-2)]);
        If (aStruturaDados[((iContador*4)-1)] ='t') or
                     (aStruturaDados[((iContador*4)-1)] ='T')  then
          bRequeridoCampo                  := True
        else
          bRequeridoCampo                  := False;

        With tTabela.FieldDefs do
        begin
           Add(Alltrim(sNomeCampo),fTipoCampo,iTamanhoCampo,bRequeridoCampo);
        end;
     end;
     tTabela.IndexDefs.Clear;
     iLimite:=(High(aIndices)+1) div 3;
     For iContador:=1 to iLimite do
     Begin
        sNomeIndice      := aIndices[(iContador*3)-3];
        sIndice          := aIndices[(iContador*3)-2];
        sChaveIndice     := aIndices[(iContador*3)-1];

        With tTabela.IndexDefs do
         Add(Rtrim(sNomeIndice),ALLTRIM(sIndice),CriaArquivoIndices(sChaveIndice));

        tTabela.CreateTable;
     end;
     Result:=True;
    end;
   except
     Result:=False;
   end;
 finally
   tTabela.Free;
 end;
end;


function ChecaCampo(sTipoCampo:String):TFieldType;
Begin
   If (sTipoCampo = 'C') or (sTipoCampo = 'c') then
       Result :=ftString
   else
     If (sTipoCampo = 'N') or (sTipoCampo = 'n') then
          Result :=ftSmallint
   else
     If (sTipoCampo = 'A') or (sTipoCampo = 'a') then
          Result :=ftString
   else
     If (sTipoCampo = 'I') or (sTipoCampo = 'i') then
          Result :=ftInteger
   else
     If (sTipoCampo = 'D') or (sTipoCampo = 'd') then
          Result :=ftDate

   else
     If (sTipoCampo = 'T') or (sTipoCampo = 't') then
          Result :=ftTime
   else
     If (sTipoCampo = '#') or (sTipoCampo = '#') then
        Result :=ftBCD
   else
     If (sTipoCampo = 'G') or (sTipoCampo = 'g') then
          Result :=ftGraphic
   else
     If (sTipoCampo = 'M') or (sTipoCampo = 'm') then
          Result :=ftMemo
   else
     If (sTipoCampo = 'L') or (sTipoCampo = 'l') then
          Result :=ftBoolean
   else
     If (sTipoCampo = 'B') or (sTipoCampo = 'b') then
          Result :=ftBoolean
   else
     If (sTipoCampo = '+') or (sTipoCampo = 'A') then
          Result :=ftAutoInc
   else
     Begin
       Result :=ftBCD;
       ShowMessage('Tipo de Campo informado no valido: '+sTipoCampo+
              #13+'Usado o Campo: ftBCD');
     end;
end;

function CriaArquivoIndices(sIndices:String):TIndexOptions;
var
  iContador,iTamanho:Integer;
  sChave:String;
Begin
   iTamanho:=length(sIndices);
   Result:=[];
   For iContador:=1 to iTamanho do
   Begin
      sChave:=Copy(sIndices,iContador,1);
      If (sChave = 'P') or (sChave = 'p') then
         Result := Result + [ixPrimary]
      else
        If (sChave = 'U') or (sChave = 'u') then
           Result := Result + [ixUnique]
      else
        If (sChave = 'D') or (sChave = 'd') then
           Result := Result + [ixDescending]
      else
        If (sChave = 'E') or (sChave = 'e') then
           Result := Result + [ixExpression]
      else
        If (sChave = 'C') or (sChave = 'c') then
           Result := Result + [ixCaseInsensitive]
      else
        Begin
           Result := Result + [ixDescending];
           ShowMessage('Indice Informado no valido: '+sChave+
                  #13+'Opo Usada no Indice: ixDescending');
        end;

   end;
end;
////////////////////////////////////////////////////////////
function AllTrim;
begin
  alltrim:=ltrim(rtrim(instring));
end;

function Rtrim(Text : string) : string;
var
  n : integer;
begin
  for n := length(Text) downto 1 do
  begin
       if Copy(Text,n,1) <> ' ' then break;
       Delete(Text,n,1);
  end;
  Result := Text;
end;


Function LTrim;
var
   n : integer;
begin
  for n :=1 to length(Text) do
  begin
     if Copy(Text,n,1) <> ' ' then break;
     Delete(Text,n,1);
  end;
  Result := Text;
end;

end.
